#!/bin/bash

AC_V="2.59"
AM_V="1.9"

AUTOCONF_VER=$(autoconf --version|head -1|tr -c -d '/[:digit:]\./')
AUTOMAKE_VER=$(automake --version|head -1|tr -c -d '/[:digit:]\./')

USAGE="
All configure scripts are build with these tools-versions:
  - Autoconf: $AC_V (you have $AUTOCONF_VER)
  - Automake: $AM_V (you have $AUTOMAKE_VER)
An error occured, you don't have one of these tools or the specific version, please check it by hand and edit this script.
"

if [ "$AUTOCONF_VER" != "$AC_V" ] || [ "$AUTOMAKE_VER" != "$AM_V" ]; then
	echo -e "$USAGE"
	exit
else
	rm -f configure config.cache config.log
	aclocal
	autoconf
	autoheader
	automake
fi


