/* cmdparser.h */

/* File autogenerated by gengetopt version 2.10  */

#ifndef CMDPARSER_H
#define CMDPARSER_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMD_PARSER_PACKAGE
#define CMD_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMD_PARSER_VERSION
#define CMD_PARSER_VERSION VERSION
#endif

struct gengetopt_args_info
{
  char * device_arg;	/* Device.  */
  char * pcap_file_arg;	/* Pcap file.  */
  char * iptrace_file_arg;	/* Iptrace file.  */
  char * snoop_file_arg;	/* Snoop file.  */
  char * filter_arg;	/* Optimized BPF filter.  */
  char * filter_nopt_arg;	/* Non-optimized BPF filter.  */
  int promisc_flag;	/* Promiscous mode (default=on).  */
  int snaplen_arg;	/* Snaplen.  */
  int beep_on_flag;	/* Alarm beep on (default=off).  */
  int max_packets_arg;	/* Maximal number of packets.  */
  int count_flag;	/* Count number of bytes (default=off).  */
  int statistic_flag;	/* Statistics (default=off).  */
  int verbose_flag;	/* Verbose mode (default=off).  */
  int expand_ethernet_flag;	/* Expand Ethernet header (default=off).  */
  int expand_llc_flag;	/* Expand LLC/SNAP header (default=off).  */
  int expand_token_flag;	/* Expand TokenRing header (default=off).  */
  int expand_fddi_flag;	/* Expand FDDI header  (default=off).  */
  int expand_arp_flag;	/* Expand ARP header (default=off).  */
  int expand_pppoe_flag;	/* Expand PPPoE header (default=off).  */
  int expand_all_flag;	/* Expand all protocol headers (default=off).  */
  int daemon_flag;	/* Daemon mode (default=off).  */
  char * logfile_arg;	/* Logfile.  */
  char * logfile_raw_arg;	/* RAW logfile.  */
  int calc_checksums_flag;	/* Calculate checksums (default=off).  */
  int print_raw_hex_flag;	/* Print RAW data in hex (default=off).  */
  int print_ip_hex_flag;	/* Print IP data in hex (default=off).  */
  int print_tcp_hex_flag;	/* Print TCP data in hex (default=off).  */
  int print_udp_hex_flag;	/* Print UDP data in hex (default=off).  */
  int print_pppoe_hex_flag;	/* Print PPPoE in hex (default=off).  */
  int print_tcp_text_flag;	/* Print TCP data in text (default=off).  */
  int print_udp_text_flag;	/* Print UDP data in text (default=off).  */
  int print_tcp_stream_flag;	/* Print reassembled TCP streams (default=off).  */
  char * module_arg;	/* Module name.  */
  char * modules_arg;	/* Directory of modules.  */
  int module_ignore_flag;	/* Ignore modules BPF filter (default=off).  */
  char * server_addr_arg;	/* Server IP address.  */
  int server_port_arg;	/* Server port.  */
  int quiet_flag;	/* Quiet mode (default=off).  */
  int really_quiet_flag;	/* Be really quiet (default=off).  */
  int no_dissection_flag;	/* Don't dissect protocols (default=off).  */
  int use_apsrlib_flag;	/* Use APSRLib instead of PCAP (default=off).  */
  int bt_arg;	/* Use Bluetooth devices.  */

  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int device_given ;	/* Whether device was given.  */
  int pcap_file_given ;	/* Whether pcap-file was given.  */
  int iptrace_file_given ;	/* Whether iptrace-file was given.  */
  int snoop_file_given ;	/* Whether snoop-file was given.  */
  int filter_given ;	/* Whether filter was given.  */
  int filter_nopt_given ;	/* Whether filter-nopt was given.  */
  int promisc_given ;	/* Whether promisc was given.  */
  int snaplen_given ;	/* Whether snaplen was given.  */
  int beep_on_given ;	/* Whether beep-on was given.  */
  int max_packets_given ;	/* Whether max-packets was given.  */
  int count_given ;	/* Whether count was given.  */
  int statistic_given ;	/* Whether statistic was given.  */
  int verbose_given ;	/* Whether verbose was given.  */
  int expand_ethernet_given ;	/* Whether expand-ethernet was given.  */
  int expand_llc_given ;	/* Whether expand-llc was given.  */
  int expand_token_given ;	/* Whether expand-token was given.  */
  int expand_fddi_given ;	/* Whether expand-fddi was given.  */
  int expand_arp_given ;	/* Whether expand-arp was given.  */
  int expand_pppoe_given ;	/* Whether expand-pppoe was given.  */
  int expand_all_given ;	/* Whether expand-all was given.  */
  int daemon_given ;	/* Whether daemon was given.  */
  int logfile_given ;	/* Whether logfile was given.  */
  int logfile_raw_given ;	/* Whether logfile-raw was given.  */
  int calc_checksums_given ;	/* Whether calc-checksums was given.  */
  int print_raw_hex_given ;	/* Whether print-raw-hex was given.  */
  int print_ip_hex_given ;	/* Whether print-ip-hex was given.  */
  int print_tcp_hex_given ;	/* Whether print-tcp-hex was given.  */
  int print_udp_hex_given ;	/* Whether print-udp-hex was given.  */
  int print_pppoe_hex_given ;	/* Whether print-pppoe-hex was given.  */
  int print_tcp_text_given ;	/* Whether print-tcp-text was given.  */
  int print_udp_text_given ;	/* Whether print-udp-text was given.  */
  int print_tcp_stream_given ;	/* Whether print-tcp-stream was given.  */
  int module_given ;	/* Whether module was given.  */
  int modules_given ;	/* Whether modules was given.  */
  int module_ignore_given ;	/* Whether module-ignore was given.  */
  int server_addr_given ;	/* Whether server-addr was given.  */
  int server_port_given ;	/* Whether server-port was given.  */
  int quiet_given ;	/* Whether quiet was given.  */
  int really_quiet_given ;	/* Whether really-quiet was given.  */
  int no_dissection_given ;	/* Whether no-dissection was given.  */
  int use_apsrlib_given ;	/* Whether use-apsrlib was given.  */
  int bt_given ;	/* Whether bt was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

int cmd_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);

void cmd_parser_print_help(void);
void cmd_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDPARSER_H */
