#include "../include/aprecv-general.h"

static const char *mtp_types[]= {
	" (Data)",
	" (NAK)",
	" (Empty)",
	" (Join)",
	" (Quit)",
	" (Token)",
	" (isMember)",
};

int print_mtp_packet (unsigned char *packet, int opt_size) {
  static struct mtp_pkt_header *mtp_header;

  mtp_header = (struct mtp_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("- MTP bridge protocol header -\n");
  apsr_output("  Dst Port: %u, Src Port: %u\n",
		  apsr_ntohs(mtp_header->dst_port),
		  apsr_ntohs(mtp_header->src_port));
  apsr_output("  Length: %u, Checksum: 0x%04x\n", 
		  apsr_ntohs(mtp_header->length),
                  apsr_ntohs(mtp_header->sum));

  apsr_output("- MTP header -\n");
  apsr_output("  Version: %u, Type: %u",
		  mtp_header->version,
		  mtp_header->type);
  if(verbose)
	  apsr_output("%s", mtp_types[mtp_header->type]);

  apsr_output("\n  Type modifier: %u, Subchannel: %u\n",
		  mtp_header->type_modifier,
		  mtp_header->sub_channel);
  apsr_output("  Source connection identifier: 0x%08x, Destination connection identifier: 0x%08x\n",
		  apsr_ntohl(mtp_header->src_connection_identifier),
		  apsr_ntohl(mtp_header->dst_connection_identifier));
  
  if(statistic) 
        stats.c.mtp++;
  
  return(RET_SUCCESS);
}
