#include "../include/aprecv-general.h"

int print_prism_mon_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  static struct prism_pkt_header *prism_header;
  static unsigned short x;
  
  prism_header = (struct prism_pkt_header *)(packet);
  
  apsr_output("\n- Prism Monitor Header -\n  Code: %d, ", prism_header->code);
  apsr_output("Length: %d, Device: \"", prism_header->length);
  for(x = 0; x < 16; x++) {
	  if(isprint(prism_header->device[x])) 
		  apsr_output("%c", prism_header->device[x]);
          else 
	          apsr_output(".");
  }
  apsr_output("\"\n  -Host Time- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->host_time.did, prism_header->host_time.status, prism_header->host_time.length, prism_header->host_time.data);
  apsr_output("  -MAC Time- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->mac_time.did, prism_header->mac_time.status, prism_header->mac_time.length, prism_header->mac_time.data);
  apsr_output("  -Channel Time- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->channel.did, prism_header->channel.status, prism_header->channel.length, prism_header->channel.data);
  apsr_output("  -RSSI- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->rssi.did, prism_header->rssi.status, prism_header->rssi.length, prism_header->rssi.data);
  apsr_output("  -SQ- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->sq.did, prism_header->sq.status, prism_header->sq.length, prism_header->sq.data);
  apsr_output("  -Signal- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->signal.did, prism_header->signal.status, prism_header->signal.length, prism_header->signal.data);
  apsr_output("  -Noise- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->noise.did, prism_header->noise.status, prism_header->noise.length, prism_header->noise.data);
  apsr_output("  -Rate- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->rate.did, prism_header->rate.status, prism_header->rate.length, prism_header->rate.data);
  apsr_output("  -isTX- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x\n", prism_header->istx.did, prism_header->istx.status, prism_header->istx.length, prism_header->istx.data);
  apsr_output("  -Frame Length- DID: 0x%08x, Status: 0x%04x, Length: %d, Data: 0x%08x", prism_header->frame_len.did, prism_header->frame_len.status, prism_header->frame_len.length, prism_header->frame_len.data);
  
  if(statistic)
	stats.c.prism_mon++;
 
  print_802_11_packet(header, packet, opt_size+data_link_size);
  
  return(RET_SUCCESS);
}
