#include "../include/aprecv-general.h"

int print_rdp_packet (unsigned char *packet, int opt_size) {
  static struct rdpv1_pkt_header *rdpv1_header;
  static struct rdpv2_pkt_header *rdpv2_header;

  rdpv1_header = (struct rdpv1_pkt_header *)(packet+data_link_size+opt_size);

  if(rdpv1_header->flags & 0x01) {
	  apsr_output("- RDPv1 Header -\n  Flags: ");

	  if(rdpv1_header->flags & 0x08) 
		  apsr_output("N ");
	  if(rdpv1_header->flags & 0x10)	  
		  apsr_output("R ");
          if(rdpv1_header->flags & 0x20)
                  apsr_output("E ");
          if(rdpv1_header->flags & 0x40)
                  apsr_output("A ");
          if(rdpv1_header->flags & 0x80)
                  apsr_output("S ");

	  apsr_output("\n  Header Length: %u, Source Port: %u, Destination Port: %u\n",
			  rdpv1_header->header_length,
			  rdpv1_header->source_port,
			  rdpv1_header->destination_port);

	  apsr_output("  Data Length: %u, Sequence Number: %u, Acknowledgement Number: %u\n",
			  apsr_ntohs(rdpv1_header->data_length),
			  apsr_ntohl(rdpv1_header->seq_num),
			  apsr_ntohl(rdpv1_header->ack_num));
	  
	  apsr_output("  Checksum: 0x%08x\n", 
			  apsr_ntohl(rdpv1_header->sum));
	  
	  if(statistic)
		  stats.c.rdpv1++;
  }
  else if(rdpv1_header->flags & 0x02) {
  	  rdpv2_header = (struct rdpv2_pkt_header *)(packet+data_link_size+opt_size);

	  apsr_output("- RDPv2 Header -\n  Flags: ");

	  if(rdpv2_header->flags & 0x08) 
		  apsr_output("N ");
	  if(rdpv2_header->flags & 0x10)	  
		  apsr_output("R ");
          if(rdpv2_header->flags & 0x20)
                  apsr_output("E ");
          if(rdpv2_header->flags & 0x40)
                  apsr_output("A ");
          if(rdpv2_header->flags & 0x80)
                  apsr_output("S ");

	  apsr_output("\n  Header Length: %u, Source Port: %u, Destination Port: %u\n",
			  rdpv2_header->header_length,
			  apsr_ntohs(rdpv2_header->source_port),
			  apsr_ntohs(rdpv2_header->destination_port));

	  apsr_output("  Data Length: %u, Sequence Number: %u, Acknowledgement Number: %u\n",
			  apsr_ntohs(rdpv2_header->data_length),
			  apsr_ntohl(rdpv2_header->seq_num),
			  apsr_ntohl(rdpv2_header->ack_num));
	  
	  apsr_output("  Checksum: 0x%08x\n", 
			  apsr_ntohs(rdpv2_header->sum));
	  
	  if(statistic)
		  stats.c.rdpv2++;
  }
  
  return(RET_SUCCESS);
}
