#include "../include/aprecv-general.h"

static const char *rsvptypes[]= {
	" (Unknown)",
	" (Path)",
	" (Resv)",
	" (PathErr)",
	" (ResvErr)",
	" (PathTear)",
	" (ResvTear)",
	" (ResvConf)",
	" (Diagnostic Request)",
	" (Diagnostic Reply)",
	" (ResvTearConfirm)",
	" (Unknown)",
	" (Bundle)",
	" (ACK)",
        " (Unknown)",
        " (Srefresh)",
        " (Unknown)",
        " (Unknown)",
        " (Unknown)",
        " (Unknown)",
        " (Hello)",
	" (Unknown)",
        " (Unknown)",
        " (Unknown)",
        " (Unknown)",
	" (Integrity Challenge)",
	" (Integrity Response)",
};

int print_rsvp_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  static struct rsvp_pkt_header *rsvp_header;
  unsigned char version, flags;

  rsvp_header = (struct rsvp_pkt_header *)(packet+data_link_size+opt_size);
  version = APSR_RSVP_VERSION(rsvp_header);
  flags = APSR_RSVP_FLAGS(rsvp_header);
  
  apsr_output("- RSVP Header -\n  Version: %u, Flags: 0x%02x", version, flags);
  apsr_output("\n  Message Type: %u", rsvp_header->msg_type);
  if(verbose)
	  apsr_output("%s", rsvptypes[rsvp_header->msg_type]);

  apsr_output("\n  Checksum: 0x%04x, Send TTL: %u\n", 
	  apsr_ntohs(rsvp_header->sum), rsvp_header->send_ttl);
  apsr_output("  Reserved: %u, Length: %u\n", 
	  rsvp_header->reserved, apsr_ntohs(rsvp_header->length));
  
  if(statistic) 
          stats.c.rsvp++;
  
  return(RET_SUCCESS);
}
