#include "../include/aprecv-general.h"
 
int usage (char *name, char *error_str) {
  apsr_stream_output((FILE *) stderr,
"\nAPRECV v%s - Programmed by APSR - Team\n"
"========================================\n"
"Usage: %s [Options]\n"
" -d    --device <device>	Device to open\n"
" -f    --filter \"filter rule\"	Set bpf filter rule, optimized\n"
" -D    --daemon			Run as daemon\n"
" -p    --promisc <0|1>		Promisc mode off(0)/on(1), default on\n"
" -c    --count			Count all bytes received\n"
"       --statistic		Count all packets received\n"
" -s    --snaplen <up to 65535>	Set the snaplen for pcap\n"
"       --max-packets <num>      Maximum packets to receive, default is loop\n"
"       --calc-checksums         Calculate checksums, print correct if wrong\n"
"       --expand-<protocol>      Expand the <protocol> header\n"
" -v    --verbose		Print out more information\n"
" -l    --logfile <file>		File to log the packets\n"
" -r    --logfile-raw <file>	File to log the packets(raw)\n"
" -R    --print-raw-hex		Print raw packet in hex\n"
"       --print<protocol>-hex   Print payload of <protocol> in hex\n"
"       --print-<protocol>-text  Print payload of <protocol> in text\n"

#ifdef HAVE_APSRLIB_MODULE_SUPPORT
"       --module <file>		Load shared module <file>\n"
"       --modules <directory>	Load all shared modules in <directory>\n"
"       --module-ignore          Ignore the builtin BPF filter of the module\n"
#endif

"       --server-addr <ip>	Open connection to APSR server\n"
"       --server-port <port>	Connect to <port>, default %u\n"
" -h    --help			Display this help message\n"
" -V    --version		Display the version\n",
    APRECV_VERSION, name, APSRSERVER_PORT);
  
  if(*error_str) {
	  apsr_stream_output((FILE *) stderr, "\nError: %s\n", error_str); 
	  exit(EXIT_FAILURE);
  }

  exit(EXIT_SUCCESS);
}

int showversion (void) {
  extern char pcap_version[];
	
  apsr_stream_output((FILE *) stderr, "APRECV version %s (c) by APSR - Team(questions@aa-security.de).\n", APRECV_VERSION);
  apsr_stream_output((FILE *) stderr, "Compiled with apsrlib version %d.%d%d, libpcap version %s.\n", 
		  APSR_APSRLIB_VERSION_BRANCH, APSR_APSRLIB_VERSION_MAJOR, 
		  APSR_APSRLIB_VERSION_MINOR, pcap_version);
  exit(EXIT_SUCCESS);
}
