#include "../include/apsend-general.h"

int usage (char *name, char *error_str) {
  apsr_stream_output((FILE *) stderr,
"\nAPSEND v%s - (c) by the APSR developer team, 2002\n"
"===================================================\n"
"Usage: %s [options]\n"
" -d	--device <device>	Device to open\n"
"	--promisc		Set promisc mode\n"
" -v	--verbose		Set verbose mode\n"
"	--module <name>		Load module <name>\n",
  APSEND_VERSION, name);

  if(*error_str) {
    apsr_stream_output((FILE *) stderr, "\nError: %s\n", error_str);
    exit(EXIT_FAILURE);
  } else {
    apsr_stream_output((FILE *) stderr, "\n");
    exit(EXIT_SUCCESS);
  }
}

int showversion (void) {
  apsr_stream_output((FILE *) stderr, "APSEND version %s (c) bye the APSR developer team (questions@aa-security.de).\n", APSEND_VERSION);
  exit(EXIT_SUCCESS);
}

