/* Include config.h generated by the configure script. */
#include "config.h"

/* Include files. */
#include "apsrlib-inc.h"
#include "apsrlib-structs.h"
#include "apsrlib-intern.h"

/* Protocol headers */
#include "./protocols/apsrlib-general.h"
#include "./protocols/apsrlib-ethernet.h"
#include "./protocols/apsrlib-apsrserver.h"
#include "./protocols/apsrlib-arp.h"
#include "./protocols/apsrlib-ipv4.h"
#include "./protocols/apsrlib-ipv6.h"
#include "./protocols/apsrlib-tcp.h"
#include "./protocols/apsrlib-ospf.h"
#include "./protocols/apsrlib-egp.h"
#include "./protocols/apsrlib-narp.h"
#include "./protocols/apsrlib-ggp.h"
#include "./protocols/apsrlib-ipx.h"
#include "./protocols/apsrlib-spx.h"
#include "./protocols/apsrlib-icmpv6.h"
#include "./protocols/apsrlib-igmp.h"
#include "./protocols/apsrlib-igrp.h"
#include "./protocols/apsrlib-rip.h"
#include "./protocols/apsrlib-pppoe.h"
#include "./protocols/apsrlib-pim.h"
#include "./protocols/apsrlib-ppp.h"
#include "./protocols/apsrlib-icmpv4.h"
#include "./protocols/apsrlib-udp.h"
#include "./protocols/apsrlib-ipcomp.h"
#include "./protocols/apsrlib-ieee802_11.h"
#include "./protocols/apsrlib-sll.h"
#include "./protocols/apsrlib-gre.h"
#include "./protocols/apsrlib-ifmp.h"
#include "./protocols/apsrlib-cdp.h"
#include "./protocols/apsrlib-tokenring.h"
#include "./protocols/apsrlib-eigrp.h"
#include "./protocols/apsrlib-vrrp.h"
#include "./protocols/apsrlib-llc.h"
#include "./protocols/apsrlib-irtp.h"
#include "./protocols/apsrlib-mopv3.h"
#include "./protocols/apsrlib-mpls.h"
#include "./protocols/apsrlib-bgp.h"
#include "./protocols/apsrlib-fddi.h"
#include "./protocols/apsrlib-tftp.h"
#include "./protocols/apsrlib-cbt.h"
#include "./protocols/apsrlib-rsvp.h"
#include "./protocols/apsrlib-chdlc.h"
#include "./protocols/apsrlib-cgmp.h"
#include "./protocols/apsrlib-gsmp.h"
#include "./protocols/apsrlib-vtp.h"

/* Return success */
#define RET_SUCCESS     1

/* Return failure */
#define RET_FAILURE     -1

/* Return NULL */
#define RET_NULL        NULL

/* Error routines */
#define INFO(a)       { fprintf(stdout, "Info : %s\n", a); }
#define ERROR(a)      { fprintf(stderr, "Error: %s\n", a); }
#define ERROR_EXIT(a) { fprintf(stderr, "Error: %s\n", a); exit(EXIT_FAILURE); }

/* Typedefs for callbacks */
typedef void (*apsr_sniff_callback)(struct sockaddr *, unsigned char *,
			                               unsigned int);

typedef void (*apsr_read_bluetooth_callback)(unsigned char *, unsigned int);

typedef void (*apsr_exit_callback)(int);


/* Some endianess stuff - this MUST be included in apsrlib.h */
/* AND in apsrlib-config.h */
#ifdef _BYTE_ORDER
#define __BYTE_ORDER _BYTE_ORDER
#endif

#ifdef _LITTLE_ENDIAN
#define __LITTLE_ENDIAN _LITTLE_ENDIAN
#endif

#ifdef _BIG_ENDIAN
#define __BIG_ENDIAN _BIG_ENDIAN
#endif

#ifdef _PDP_ENDIAN
#define __PDP_ENDIAN    _PDP_ENDIAN
#endif

