#define APSR_PPPOE_CODE_PADI		0x0900	/* PPPoE Active Discovery Initiation */
#define APSR_PPPOE_CODE_PADO		0x0700	/* PPPoE Active Discovery Offer */
#define APSR_PPPOE_CODE_PADR		0x1900	/* PPPoE Active Discovery Request */
#define APSR_PPPOE_CODE_PADS		0x6500	/* PPPoE Active Discovery Session-confirmation */
#define APSR_PPPOE_CODE_PADT		0xa700	/* PPPoE Active Discovery Terminate */
#define APSR_PPPOE_CODE_SESS		0x0000	/* PPPoE Session Stage  */

/* Extension found in draft-carrel-info-pppoe-ext-00 */
#define APSR_PPPOE_CODE_PADM            0xd300
#define APSR_PPPOE_CODE_PADN		0xd400	

#define APSR_PPPOE_VERSION(pppoe_pkt_header) (((pppoe_pkt_header)->pppoe_vhl & 0xf0) >> 4)
#define APSR_PPPOE_TYPE(pppoe_pkt_header) ((pppoe_pkt_header)->pppoe_vhl & 0x0f) 

#define APSR_PPPOE_TAG_END		0x0000		/* End-Of-List	*/
#define APSR_PPPOE_TAG_SERVICE		0x0101		/* Session Name	*/
#define APSR_PPPOE_TAG_AC_NAME		0x0102 		/* AC-Name	*/
#define APSR_PPPOE_TAG_HOST_UNIQ	0x0103		/* Host-Uniq	*/
#define APSR_PPPOE_TAG_AC_COOKIE	0x0104		/* AC-Cookie	*/
#define APSR_PPPOE_TAG_VENDOR		0x0105		/* Vendor-Specific    */
#define APSR_PPPOE_TAG_RELAY_ID		0x0110		/* Relay-Session-ID   */
#define	APSR_PPPOE_TAG_SERVICE_ERR	0x0201		/* Service-Name-Error */
#define APSR_PPPOE_TAG_AC_ERR		0x0202		/* AC-System-Error    */
#define APSR_PPPOE_TAG_GENERIC_ERR	0x0203		/* Generic-Error      */

