#include "../include/apsrlib-config.h"

/* Create a EGP packet. */
int apsr_egp (unsigned int version, unsigned int type, unsigned int code,
	      unsigned int status, unsigned short sum, unsigned short auto_sys,
	      unsigned int seq, const unsigned char *payload, int payload_size,
	      unsigned char *buf)
{
	static struct egp_pkt_header egp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_egp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	egp_hdr.version 	= version;
	egp_hdr.type		= type;
	egp_hdr.code		= code;
	egp_hdr.status		= status;
	egp_hdr.sum		= apsr_htons(sum);
	egp_hdr.auto_sys	= apsr_htons(auto_sys);
	egp_hdr.sequence	= apsr_htons(seq);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_EGP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&egp_hdr,
	       APSR_EGP);

	return(RET_SUCCESS);
}

