#include "../include/apsrlib-config.h"


/* Update the buffer and set the SNAP / LLC header.   */
/* This function MUST be called AFTER apsr_ethernet ! */
int apsr_ethernet_snap (unsigned char dsap, unsigned char ssap,
			unsigned char control, unsigned char org_id[2],
			unsigned short type, unsigned char *buf)
{
	struct ethernet_pkt_header ethernet_snap_hdr;

	ethernet_snap_hdr.ext.snap.dsap		= dsap;
	ethernet_snap_hdr.ext.snap.ssap		= ssap;
	ethernet_snap_hdr.ext.snap.control 	= control;
	memcpy(ethernet_snap_hdr.ext.snap.org_id, org_id, 3);
	ethernet_snap_hdr.ext.snap.type		= type;
	

	/* Copy the ethernet header to the buffer. */
	memcpy(buf, &ethernet_snap_hdr, sizeof(ethernet_snap_hdr));
	
	return(RET_SUCCESS);
}

/* Create a ethernet packet. */
int apsr_ethernet (unsigned char *dst, unsigned char *src, unsigned short type,
		   const unsigned char *payload, int payload_size,
		   unsigned char *buf)
{

	struct ethernet_pkt_header ethernet_hdr;

	/* Check the buffer. */
	if(!buf) return(RET_FAILURE);

	memcpy(ethernet_hdr.destination, dst, APSR_ETHER_ADDR_LEN);
	memcpy(ethernet_hdr.source, src, APSR_ETHER_ADDR_LEN);
	ethernet_hdr.type=apsr_htons(type);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_ETH, payload, payload_size);
	}


	/* Copy the ethernet header to the buffer. */
	memcpy(buf, &ethernet_hdr, APSR_ETH);
	return(RET_SUCCESS);
}

