#include "../include/apsrlib-config.h"

/* Create a IRTP packet. */
int apsr_irtp (unsigned char type, unsigned char port, unsigned short seq_num,
	       unsigned short length, unsigned short sum,
	       const unsigned char *payload, int payload_size,
	       unsigned char *buf)
{
	static struct irtp_pkt_header irtp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_irtp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	irtp_hdr.type	 	= type;
	irtp_hdr.port		= port;
	irtp_hdr.seq_num	= htons(seq_num);
	irtp_hdr.length		= htons(length);
	irtp_hdr.sum		= htons(sum);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_IRTP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&irtp_hdr,
	       APSR_IRTP);

	return(RET_SUCCESS);
}

