#include "../include/apsrlib-config.h"

/* Malloc wrapper. */
void * xmalloc (size_t size) {
	register void *value;
	
	value = malloc(size);

	if(value == 0)
	  ERROR_EXIT("Virtual memory exhausted.");

	return(value);
}


/* Realloc wrapper. */
void * xrealloc (void *ptr, size_t size) {
	register void *value;

	value = realloc(ptr, size);
  
	if (value == 0)
	  ERROR_EXIT("Virtual memory exhausted.");

	return(value);
}


/* Calloc wrapper. */
void * xcalloc (size_t nmemb, size_t size) {
	register void *value;

	value = calloc(nmemb, size);

	if (value == 0)
	  ERROR_EXIT("Virtual memory exhausted.");

	return(value);
}

