#include "../include/apsrlib-config.h"

/* Create a RIPng packet. */
int apsr_ripng (unsigned int command, unsigned int version,
		unsigned short unused, const unsigned char *payload,
		int payload_size, unsigned char *buf)
{
	static struct ripng_pkt_header ripng_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_ripng: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	ripng_hdr.command	= command;
	ripng_hdr.version	= version;
	ripng_hdr.unused	= apsr_htons(unused);
	
	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_RIPng, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&ripng_hdr,
	       APSR_RIPng);

	return(RET_SUCCESS);
}

