#include "../include/apsrlib-config.h"

/* Create a SCTP packet. */
int apsr_sctp (unsigned short src_port, unsigned short dst_port,
	       unsigned int v_tag, unsigned int sum,
	       const unsigned char *payload, int payload_size,
	       unsigned char *buf)
{
	static struct sctp_pkt_header sctp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_sctp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	sctp_hdr.src_port	= htons(src_port);
	sctp_hdr.dst_port	= htons(dst_port);
	sctp_hdr.v_tag		= htonl(v_tag);
	sctp_hdr.sum		= htonl(sum);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_SCTP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&sctp_hdr,
	       APSR_SCTP);

	return(RET_SUCCESS);
}

