#include <stdio.h>
#include <string.h>
#include <apsrlib/apsrlib.h>

int main (void) {
	int fd;
	int my_ret, written;

	unsigned char *buf;

	/* Open a link layer interface. */
	fd = apsr_open_raw_socket(IPPROTO_TCP, PF_INET);

	/* Initialize the packet memory. */
	/* We need 20 bytes for the IPv4 header. */
	my_ret = apsr_init_psize(APSR_IPv4_H, &buf);

	if(my_ret == 0 || buf == NULL) ERROR("apsr_init_psize failed!");

	/* Build test packet */
 	my_ret = apsr_ipv4(4,			// IP version
			   5,			// IP header length
			   0,			// IP length
			   0x1111,		// IP Type of Service (ToS)
			   45360,		// IP Identification (ID)
			   0x4000,		// IP Fragementation offset
			   64,			// IP Time to live (TTL)
			   0,			// IP transport layer protocol
			   inet_addr("127.0.0.3"), // Source IP
			   inet_addr("127.0.0.2"), // Destination IP
			   0,			// IP checksum
			   NULL,		// IP options
			   0,			// IP option size
			   NULL,		// IP payload
			   0,			// IP payload length
			   buf);	// Packet buffer

	if(my_ret == -1) ERROR("apsr_ipv4 failed!");

	/* Send it */
	written = apsr_write_raw_socket(fd, buf, APSR_IPv4_H, inet_addr("127.0.0.1"), 1024, 1000);

	apsr_output("Wrote %i bytes!\n", written);
	
	/* Close link layer */
	apsr_close_raw_socket(fd);
	
	return(RET_SUCCESS);
}


