#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"crane"
#define MODULE_DESCRIPTION	"Example CRANE protocol sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_SCTP
#define MODULE_IDENT_PN2	APSR_PROTO_TCP
#define MODULE_IDENT_ID1	65535 /* not known */
#define MODULE_IDENT_ID2	65535 /* not known */

#define MODULE_FILTER		"port 65535"

struct mod_crane_header {
	unsigned char version;
	unsigned char type;
	unsigned char session_id;
	unsigned char flags;
	unsigned int length;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = MODULE_IDENT_PN2;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_crane_header *crane_header;
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    crane_header = (struct mod_crane_header *)buf;
	    apsr_output("- CRANE Header -\n");
	    apsr_output("  Version: %u, Type: %u\n", crane_header->version, 
			    crane_header->type);
	    apsr_output("  Session ID: %u, Flags: 0x%02x\n", 
			    crane_header->session_id,
			    crane_header->flags);
	    apsr_output("  Length: %u\n", apsr_ntohl(crane_header->length));
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
