#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"tdp"
#define MODULE_DESCRIPTION	"Example Tag Distribution Protocol sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_ID1	711
#define MODULE_IDENT_ID2	711

#define MODULE_FILTER		"tcp and port 711"

struct mod_tdp_header {
	unsigned short version;
	unsigned short length;
	unsigned char tdp_ident[6];
	unsigned short reserved;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = 0;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_tdp_header *tdp_header;
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    tdp_header = (struct mod_tdp_header *)buf;
	    apsr_output("- TDP Header -\n");
	    apsr_output("  Version: %u, Length: %u\n", 
			    apsr_ntohs(tdp_header->version),
			    apsr_ntohs(tdp_header->length));
	    apsr_output("  TDP Identifier: %02x%02x%02x%02x%02x%02x, Reserved: %u\n",
			    tdp_header->tdp_ident[0],
			    tdp_header->tdp_ident[1],
			    tdp_header->tdp_ident[2],
			    tdp_header->tdp_ident[3],
			    tdp_header->tdp_ident[4],
			    tdp_header->tdp_ident[5],
			    apsr_ntohs(tdp_header->reserved));
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
